
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include "midasdll.h"
#include "vesavbe.h"
#include "hires256.h"
#include "stuff.h"
#include "obj3d.h"

// demo parts
#include "intro.h"
#include "deforms.h"
#include "credits.h"
#include "rings.h"
#include "metaball.h"
#include "knots.h"
#include "final.h"


//      Global stuff

MIDASmodule module;
char *modulename = "alqui.xm";


void MIDAS_CALL TimerCallback() { Timer100++; }


void main() {
        printf("Alchemy by Delabu Alama - please wait...\n");
        VBE_Init();
        InitializeEngine();
        Intro_Setup();
        Deforms_Setup();
        Credits_Setup();
        Rings_Setup();
        Metaball_Setup();
        Knots_Setup();
        Final_Setup();

        MIDASstartup();
	MIDASdetectSoundCard();
	MIDASconfig();
	MIDASinit();
	module = MIDASloadModule(modulename);

        Timer100 = 0;
//        MIDASsetTimerCallbacks(100000, FALSE, &TimerCallback, NULL, NULL);

        SetHiResMode();
        lastresult = OK;

        playhandle = MIDASplayModule(module, TRUE);
        GetMusicInfo();

        Intro();
        if (lastresult == OK) { Deform2(); }
        if (lastresult == OK) { Deform1(); }
        if (lastresult == OK) { Credits(); }
        if (lastresult == OK) { Rings(); }
        if (lastresult == OK) { Metaball1(); }
        if (lastresult == OK) { Metaball2(); }
        if (lastresult == OK) { Knots(); }
        if (lastresult == OK) { Deform3(); }
        if (lastresult == OK) { Deform4(); }
        if (lastresult == OK) { Final(); }


//        MIDASremoveTimerCallbacks();

	MIDASstopModule(playhandle);
	MIDASfreeModule(module);
	MIDASclose();

        Intro_Free();
        Deforms_Free();
        Credits_Free();
        Rings_Free();
        Metaball_Free();
        Knots_Free();
        Final_Free();

        VBE_SetMode(3, 0, 1);
        VBE_Done();
        printf("Share it with your friends!\n\n");
}
