
// phongpal.cpp

#include <math.h>
#include "hires256.h"
#include "phongpal.h"

void PhongPal( double ra, double rd, double rs,
               double ga, double gd, double gs,
               double ba, double bd, double bs,
               unsigned int n, 
               TPalette p, unsigned int start, unsigned int range) {

        double r, g, b;
	if (range > 256) range = 256;
	double ang = 3.14159265 / 2.0;
	double angadd = (3.14159265 / range) / 2.0;
	for (int i = 0; i < range; i++) {
                r = ra + cos(ang) * rd + pow(cos(ang), n) * rs;
                if (r > 1.0) r = 1.0;
		
                g = ga + cos(ang) * gd + pow(cos(ang), n) * gs;
                if (g > 1.0) g = 1.0;
		
                b = ba + cos(ang) * bd + pow(cos(ang), n) * bs;
                if (b > 1.0) b = 1.0;
		
                p[start + i][0] = r * 63.0;
                p[start + i][1] = g * 63.0;
                p[start + i][2] = b * 63.0;
		
		ang -= angadd;
	}
}
